;;; DERIV -- Symbolic derivation.

;;; Returns the wrong answer for quotients.
;;; Fortunately these aren't used in the benchmark.

(define (deriv a)
  (cond ((not (pair? a))
         (if (equal? a 'x) 1 0))
        ((equal? (car a) '+)
         (cons '+
               (map deriv (cdr a))))
        ((equal? (car a) '-)
         (cons '-
               (map deriv (cdr a))))
        ((equal? (car a) '*)
         (list '*
                a
                (cons '+
                      (map (lambda (a) (list '/ (deriv a) a)) (cdr a)))))
        ((equal? (car a) '/)
         (list '-
               (list '/
                     (deriv (cadr a))
                     (caddr a))
               (list '/
                     (cadr a)
                     (list '*
                           (caddr a)
                           (caddr a)
                           (deriv (caddr a))))))
        (else
         (fatal-error "No derivation method available"))))
(define (loop n)
  (deriv '(+ (* 3 x x) (* a x x) (* b x) 5))
  (if (> n 0) (loop (- n 1))))
(loop 50000)

