
;; http://en.literateprograms.org/Merge_sort_(Scheme)

(define split
  (lambda (ls)
    (define split-h (lambda (ls ls1 ls2)
			  (if (or (null? ls) (null? (cdr ls)))
			   (cons (reverse ls2) ls1)
			  (split-h (cddr ls)
					 (cdr ls1) (cons (car ls1) ls2)))))
      (split-h ls ls '())))

;(display (split '(1 2 3 4 5)))


(define merge
  (lambda (pred ls1 ls2)
    (if (null? ls1) ls2
      (if (null? ls2) ls1
	(if (pred (car ls1) (car ls2))
	  (cons (car ls1) (merge pred (cdr ls1) ls2))
	  (cons (car ls2) (merge pred ls1 (cdr ls2))))))))


(define merge-sort
  (lambda (pred ls)
    (if (null? ls) ls
      (if (null? (cdr ls)) ls
	(let ((splits (split ls)))
	      (merge pred
		     (merge-sort pred (car splits))
		     (merge-sort pred (cdr splits))))))))


(define (random-list len)
  (define (generate len p q s result)
    (if (= len 0) result
      (let ((value (modulo (* s s) (* p q))))
	(generate (- len 1) p q value (cons value result)))))
  (generate len 101 17 3 '()))

(merge-sort < (random-list 100000))






