;; http://www.cs.hofstra.edu/~cscccl/csc123/quicksort.scm
;;

(define pivot (lambda (l)
		(cond ((null? l) 'done)
		      ((null? (cdr l)) 'done)
		      ((<= (car l) (cadr l)) (pivot (cdr l)))
		      (#t (car l)))))

; usage: (partition 4 '(6 4 2 1 7) () ()) -> returns partitions

(define partition (lambda (piv l p1 p2)
		    (if (null? l) (list p1 p2)
		      (if (< (car l) piv) (partition piv (cdr l) (cons (car l) p1) p2)
			(partition piv (cdr l) p1 (cons (car l) p2))))))

(define (quicksort l)
  (let ((piv (pivot l)))
    (if (equal? piv 'done) l
      (let ((parts (partition piv l '() '())))
	(append (quicksort (car parts)) 
		(quicksort (cadr parts)))))))

(define (random-list len)
  (define (generate len p q s result)
    (if (= len 0) result
      ((lambda (value) 
	(generate (- len 1) p q value (cons value result)))
	(modulo (* s s) (* p q)))
      ))
  (generate len 101 17 3 '()))

(quicksort (random-list 500000))

