;;; SUMLOOP -- One of the Kernighan and Van Wyk benchmarks.

(define sum 0)

(define (tail-rec-aux i n)
  (if (< i n)
      (begin (set! sum (+ sum 1)) (tail-rec-aux (+ i 1) n))
      sum))

(define (tail-rec-loop n)
  (set! sum 0)
  (tail-rec-aux 0 n)
  sum)

(define (do-loop n)
  (set! sum 0)
  (let loop ((i 0))
      (if (>= i n) sum
	(begin
	  (set! sum (+ sum 1))
	  (loop (+ i 1))))))

(do-loop 1000000)

