; "determ.scm" Determinant
; http://inst.eecs.berkeley.edu/~cs3s/stk/slib/determ.scm
; modified by me ;-]

(define (negative? x) (< x 0))
(define (odd? x) (> (modulo x 2) 0))
(define (zero? x) (= x 0))

(define (determinant m)
  (define (butnth n lst)
    (if (zero? n) (cdr lst) (cons (car lst) (butnth (+ -1 n) (cdr lst)))))
  (define (minor m i j)
    (map (lambda (x) (butnth j x)) (butnth i m)))
  (define (cofactor m i j)
    (* (if (odd? (+ i j)) -1 1) (determinant (minor m i j))))
  (define n (length m))
  (if (= n 1) (caar m)
;    (do ((j (+ -1 n) (+ -1 j))
;	 (ans 0 (+ ans (* (list-ref (car m) j) (cofactor m 0 j)))))
;      ((negative? j) ans))))
	(let loop ((j (+ -1 n))
		   (ans 0))
	  (if (negative? j) 0
	    (+ (* (list-ref (car m) j) (cofactor m 0 j)) (loop (+ -1 j) 0)  )))))

(define (matrix-create n value)
    (define (iter m v)
          (if (= m 0) '() (cons v (iter (- m 1) v))))
      (iter n (iter n value)))

(display (determinant (matrix-create 9 1)))
;(display (determinant '((1 0 0) (0 2 0) (0 0 3))))
