(define (map* fn list)
  (apply append (map fn list)))

(define context-RB
  '((1   3 4)
    (  2 3 4)
    (1 2 3 4)
    (1      )))

(define context-school
  '((1 4 5 7)
    (1 2 4 5)
    (3 4 7)
    (0 2 4 6)
    (2 4 5 6)
    (0 4 6)
    (0 4 6 8)))

(define context-paleo2
  '((2 3 8 13 16 23 26)
    (0 1 2 3 4 5 6 9 10 11 15 17 20 26 27 30 31 35)
    (0 1 2 4 5 6 10 11 15 17 20 21 26 27 30 31 33 34 35)
    (1 4 9 15 17 20 21 27 34 35)
    (0 1 2 4 10 11 15 19 22 26 27 33 34 35)
    (0 5 11 15 19 21 26 27 31 35)
    (0 1 2 4 10 11 15 16 20 26 27 30)
    (1 2 4 10 11 15 17 20 21 26 27 31 33 34 35)
    (1 4 10 11 15 17 20 26 27 30 33 34 35)
    (1 6 12 15 19 20 26 35)
    (1 4 11 15 18 20 26 27 30 33 34)
    (1 3 6 11 15 19 21 26 27 35)
    (1 2 5 6 11 15 19 21 27 31)
    (1 4 11 15 19 20 21 27 31 35)
    (1 2 10 11 15 19 21 26 27 30 33 34)
    (2 3 5 11 15 18 19 21 26 27 31 33 34)
    (1 4 11 14 15 19 20 24 25 26 27 30 33 34 35)))

(define (intersect-aux list1 list2)
  (cond ((null? list1) '())
        ((null? list2) '())
        ((< (car list1) (car list2)) (intersect-aux (cdr list1) list2))
        ((> (car list1) (car list2)) (intersect-aux list1 (cdr list2)))
        (#t (cons (car list1) (intersect-aux (cdr list1) (cdr list2))))))

(define (union-aux list1 list2)
  (cond ((null? list1) list2)
        ((null? list2) list1)
        ((< (car list1) (car list2)) (cons (car list1) (union-aux (cdr list1) list2)))
        ((> (car list1) (car list2)) (cons (car list2) (union-aux list1 (cdr list2))))
        (#t (cons (car list1) (union-aux (cdr list1) (cdr list2))))))
(define (union sets)
  (if (null? sets) sets
      (union-aux (car sets) (union (cdr sets)))))

(define (intersect sets)
  (cond ((null? sets) '())
        ((= (length sets) 1) (car sets))
        ((intersect-aux (car sets) 
                        (intersect (cdr sets))))))
(define (enumerate from context)
  (if (null? context) '()
      (cons (cons from (car context))
	    (enumerate (+ from 1) (cdr context)))))

(define (assoc item list)
  (cond ((null? list) #f)
	((equal? item (caar list)) (car list))
	(else (assoc item (cdr list)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; closure ( <objects> . <attributes> )
(define (fafca context)
  
  (let* ((context-pk (enumerate 1 context))
         (initial-closure (cons (map car context-pk) '()))
         (attributes (union context))
         (context-by-attr (map (lambda (attr) 
                                 (cons attr (map* (lambda (obj)
                                                    (if (member attr (cdr obj)) (list (car obj)) '()))
                                                  context-pk)))
                               attributes)))
    
    (define (compute-closure concept attr)
      (let* ((ext (intersect-aux (car concept) 
                                 (cdr (assoc attr context-by-attr))))
             (int (intersect (cons attributes
                                   (map (lambda (x)
                                          (cdr (assoc x context-pk)))
                                        ext)))))
        (cons ext int)))
    
    (define (compare-to-skip a1 a2 i)
      (cond ((null? a2) #t)
            ((>= (car a2) i) #f)
            ((null? a1) #t)
            ((= (car a1) (car a2)) (compare-to-skip (cdr a1) (cdr a2) i))
            (else #t)))
    
    (define (generate-from concept y)
      ;  (display concept) (newline)
      (append (list concept)
              (map* (lambda (j)
                      (if (and (>= j y) (not (member j (cdr concept))))
                          (let ((closure (compute-closure concept j)))
                            (if (not (compare-to-skip (cdr concept) (cdr closure) j))
                                (generate-from closure (+ 1 j))
                                '()))
                          '()))
                    attributes)))
    
    (generate-from initial-closure 0)
    ))


(define (non-equiv n)
  (let loop-rows ((r n)
                  (result '()))
    (if (= r 0) result
        (loop-rows (- r 1)
                   (cons (let loop-cell ((c n)
                                         (rx '()))
                           (if (= c 0) rx
                               (loop-cell (- c 1)
                                          (cons (if (= c r) 0 1) rx))))
                         result)))))
(define xx-paleo
  (append context-paleo2 context-paleo2 context-paleo2 context-paleo2 context-paleo2 context-paleo2 context-paleo2))
(display (length (fafca xx-paleo)))

;(display (length (fafca context-paleo2)))
(newline)
