(define (matrix-create n value)
  (define (iter m v)
    (if (= m 0) () (cons v (iter (- m 1) v))))
  (iter n (iter n value)))

(define (matrix-get-row m r)
  (if (= r 0) (car m) (matrix-get-row (cdr m) (- r 1)))) 

(define (matrix-get m r c)
  (list-ref (list-ref m r) c))

(define (add m n)
  (map (lambda (r1 r2)
	 (map (lambda (c1 c2) (+ c1 c2)) r1 r2))
	 m n))

(define SIZE 2000)
(define A (matrix-create SIZE 1))
(define B (matrix-create SIZE 4))
(add A B)

