
(define (matrix-create n value)
  (define (iter m v)
    (if (= m 0) '() (cons v (iter (- m 1) v))))
  (iter n (iter n value)))

(define (matrix-get-row m r)
  (if (= r 0) (car m) (matrix-get-row (cdr m) (- r 1)))) 

(define (matrix-get m r c)
  (list-ref (list-ref m r) c))

(define (seq from to)
  (if (= from to) (list to) (cons from (seq (+ from 1) to))))

(define (multiply-scalar m k)
  (map (lambda (row)
	 (map (lambda (cell) (* cell k)) row)
	 ) m))

(define (add m n)
  (define (add-rows r1 r2)
    (if (null? r1) r1
      (cons (+ (car r1) (car r2)) (add-rows (cdr r1) (cdr r2)))))
  (define (iter-row m n)
    (if (null? m) m
      (cons (add-rows (car m) (car n)) (iter-row (cdr m) (cdr n)))))
  (iter-row m n))


(define (multiply m n)
  (define size (length m))
  (define (get-element row cell)
    (define (iter i result)
      (if (= i size) result
      	(iter (+ i 1) (+ result (* (matrix-get m row i) (matrix-get n i cell))))))
    (iter 0 0)) 
  (define (iter-cell row cell)
    (if (= cell size) '()
      (cons (get-element row cell) (iter-cell row (+ cell 1)))))
  (define (iter-row row)
    (if (= row size) '()
      (cons (iter-cell row 0) (iter-row (+ row 1)))))
  (iter-row 0))


(define SIZE2 50)
(define C (matrix-create SIZE2 1))
(define D (matrix-create SIZE2 1))
;(define C '((1 2 3) (4 5 6) (7 8 9)))
;(define D '((1 1 1) (2 2 2) (3 3 3)))
(multiply C D)
