(define (assoc item list)
  (cond ((null? list) #f)
	((equal? item (caar list)) (car list))
	(else (assoc item (cdr list)))))

(define (fib x)
    (if (< x 3) 1 (+ (fib (- x 1)) (fib (- x 2)))))

(define (fib1 x)
    (if (< x 3) 1 (+ (fib1 (- x 1)) (fib1 (- x 2)))))
(define (fib2 x)
    (if (< x 3) 1 (+ (fib2 (- x 1)) (fib2 (- x 2)))))


(define (memoize fn)
  (let ((table '()))
    (lambda args
      (let ((val (assoc args table)))
        (if val (cdr val)
            (let ((val (apply fn args)))
              (set! table (cons (cons args val) table))
              val))))))

(define fib1 (memoize fib1))
(define fib2 (memoize fib2))
(display (+ (fib1 10000) (fib1 10000))) (newline)

