(define (fib x) (if (< x 3) 1 (+ (fib (- x 1)) (fib (- x 2)))))
(define (fakt x) 
	(if (= x 0) 1 
		(* x (fakt (- x 1)))))
(define xxx 1)
(define r1 1)
(define r2 1)
(define (counter x) 
	(lambda () (set! x (+ x 1)) x))

(define c1 (counter 10))
(define c2 (counter 20))

;; evaluation test, functions
(displayn (+ (* (+ 1 1) 3) (* 4 (+ 2 3))))
(displayn (fib 15))
(displayn (fib 15))
(displayn (fakt 10))

;; sync test
(displayn fib)
(begin 
	(set! r1 (* (fib 30) xxx))
	(set! r2 (* 2 r1)) 
	(set! xxx (fib 30)))
(displayn r1)
(displayn r2)
(displayn xxx)
(newline)

;; closures
(displayn (c1))
(displayn (c1))
(displayn (c1))
(displayn (c2))
(displayn (c2))
(displayn (c1))
(newline)

;; lists
(define l1 (list 1 2 3))
(define l2 (list 4 5 6))
(displayn (append l1 l2))
(displayn (map (lambda (x) (* x 2)) (append l1 l2)))
(newline)

;; misc
(displayn (let 
		((a 2) 
		(b 3)) 
		(* a b)))
(begin 
	(display 10) 
	(newline) 
	(display 20) 
	(newline))
