(define (map-tree fn items)
  (define (make-leaves items)
    (map (lambda (x) (list 'leaf x)) items))
  
  (define (join-trees trees)
    (let loop ((remaining trees)
               (joined '()))    
      (if (or (null? remaining) (null? (cdr remaining)))
          (append joined remaining)
          (loop (cddr remaining)
                (append joined (list (list 'node (car remaining) (cadr remaining))))))))
  (define (build-tree items)
    (let loop ((sub-trees (make-leaves items)))
      (if (or (null? sub-trees) (null? (cdr sub-trees))) sub-trees
          (loop (join-trees sub-trees)))))
  (define (dispatch x)
    (cond 
        ((null? x) '())
        ((equal? (car x) 'leaf) (list (apply fn (cdr x))))
	((= (length x) 2) (apply append (list (dispatch (cadr x)))))
        (else  (apply append (list (dispatch (cadr x)) (dispatch (caddr x)))))))
  (dispatch (car (build-tree items))))


(define (seq from to)
      (if (= from to) (list to) (cons from (seq (+ from 1) to))))
(map-tree (lambda (x) (* x x)) (seq 1 10000))
  
